"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var StoreListProxy_1 = require("../StoreListProxy");
describe("StoreListProxy", function () {
    test("should can proxy other methods", function () {
        var storeDispatcher = {
            handleDispatch: jest.fn(),
            handleDispatchNoReturn: jest.fn(),
            handleDispatchDisposable: jest.fn(),
        };
        var newStore = new StoreListProxy_1.StoreListProxy(storeDispatcher, "helloStore");
        newStore.setSize(2);
        expect(storeDispatcher.handleDispatchNoReturn).toHaveBeenLastCalledWith({
            store: "helloStore",
            method: "setSize",
            args: [2],
        });
        expect(newStore.storeArray.length).toEqual(2);
        expect(newStore.get(1).doSome("hello", "do"));
        expect(storeDispatcher.handleDispatch).toHaveBeenLastCalledWith({
            store: "helloStore",
            index: 1,
            method: "doSome",
            args: ["hello", "do"],
        });
    });
});
